Home | Download | Screen shots | Discussion | Documentation
--- | --- | --- | --- | ---

Main Page | Modules | Namespace List | Class Hierarchy | Class List | Namespace Members | Class Members | Related Pages

# openvrml::mfcolor Class Reference
[Field Values]

Inheritance diagram for openvrml::mfcolor:

[legend]
List of all members.

## Detailed Description

A color array node field value.

Model of
  FieldValue

## Public Types
typedef std::vector< color > | value_type
| The type of value.
## Public Member Functions
| mfcolor (std::vector< color >::size_type n=0, const color &value=color()) throw (std::bad_alloc)
| Construct.
| mfcolor (const std::vector< color > &value) throw (std::bad_alloc)
| Construct.
template<typename InputIterator>
| mfcolor (InputIterator first, InputIterator last)
| Create an mfcolor with a copy of a range.
virtual | ~mfcolor () throw ()
| Destroy.
virtual std::auto_ptr< field_value > | clone () const throw (std::bad_alloc)
| Virtual copy constructor.
virtual field_value & | assign (const field_value &value) throw (std::bad_cast, std::bad_alloc)
| Virtual assignment.
virtual type_id | type () const throw ()
| Get the field_value::type_id associated with this class.
## Public Attributes
std::vector< color > | value
| Color values.
## Private Member Functions
virtual void | print (std::ostream &) const
| Print to an output stream.
## Related Functions
(Note that these are not member functions.)
bool | operator== (const mfcolor &lhs, const mfcolor &rhs) throw()
| Compare for equality.
bool | operator!= (const mfcolor &lhs, const mfcolor &rhs) throw()
| Compare for inequality.
template<> void | swap (openvrml::mfcolor &a, openvrml::mfcolor &b)
| Swap the values of `a` and `b`.

## Member Typedef Documentation

openvrml::mfcolor::value_type

| The type of value.

## Constructor & Destructor Documentation

openvrml::mfcolor::mfcolor | ( | std::vector< color >::size_type | n = `0`,
|  | const color & | value = `color()`
| ) | throw (std::bad_alloc)`[explicit]`

  | Construct. Creates an mfcolor with `n` copies of `value`. Parameters:
  | n | the number elements in the mfcolor.
  | value | used to initialize the mfcolor.
  Exceptions:
  | std::bad_alloc | if memory allocation fails.
Postcondition: size is `n`. Every element is a copy of `value`.

openvrml::mfcolor::mfcolor | ( | const std::vector< color > & | value | ) | throw (std::bad_alloc)`[explicit]`

  | Construct. Parameters:
  | value | initial value.
  Exceptions:
  | std::bad_alloc | if memory allocation fails.

template<typename InputIterator>
openvrml::mfcolor::mfcolor | ( | InputIterator | first,
|  | InputIterator | last
| ) |

  | Create an mfcolor with a copy of a range. Creates an mfcolor with a value that is a copy of the range [`first`, `last`). Parameters:
  | first | an iterator pointing to the beginning of the range.
  | last | an iterator pointing one past the end of the range.

openvrml::mfcolor::~mfcolor | ( |  | ) | throw ()`[virtual]`

| Destroy. Each of the mfcolor's value elements is destroyed, and memory allocated for them (if any) is deallocated.

## Member Function Documentation

std::auto_ptr< field_value > openvrml::mfcolor::clone | ( |  | ) | const throw (std::bad_alloc)`[virtual]`

  | Virtual copy constructor. Returns: a pointer to a copy of the object. Exceptions:
  | std::bad_alloc | if memory allocation fails.
Implements openvrml::field_value.

field_value & openvrml::mfcolor::assign | ( | const field_value & | value | ) | throw (std::bad_cast, std::bad_alloc)`[virtual]`

  | Virtual assignment. Returns: a reference to the object. Exceptions:
  | std::bad_cast | if `value` is not an mfcolor object.
  | std::bad_alloc | if memory allocation fails.
Implements openvrml::field_value.

field_value::type_id openvrml::mfcolor::type | ( |  | ) | const throw ()`[virtual]`

| Get the field_value::type_id associated with this class. Returns: `field_value::mfcolor`. Implements openvrml::field_value.

void openvrml::mfcolor::print | ( | std::ostream & | out | ) | const`[private, virtual]`

  | Print to an output stream. Parameters:
  | out | an output stream.
Implements openvrml::field_value.

## Friends And Related Function Documentation

bool operator== | ( | const mfcolor & | lhs,
|  | const mfcolor & | rhs
| ) | throw()`[related]`

  | Compare for equality. Parameters:
  | lhs | left-hand operand.
  | rhs | right-hand operand.
Returns: `true` if `lhs` and `rhs` have the same value; `false` otherwise.

bool operator!= | ( | const mfcolor & | lhs,
|  | const mfcolor & | rhs
| ) | throw()`[related]`

  | Compare for inequality. Parameters:
  | lhs | left-hand operand.
  | rhs | right-hand operand.
Returns: `true` if `lhs` and `rhs` do not have the same value; `false` otherwise.

template<> void swap | ( | openvrml::mfcolor & | a,
|  | openvrml::mfcolor & | b
| ) | `[related]`

  | Swap the values of `a` and `b`. Does not throw. Parameters:
  | a |
  | b |

## Member Data Documentation

std::vector< color > openvrml::mfcolor::value

| Color values.